#include <iarduino_HC_SR04.h>
iarduino_HC_SR04 sensor(12,11);
// 12 <-> trig pin(HC_SR04), 11 <-> echo pin(HC_SR04)

#define MIN_POS 16
#define MAX_POS 16
//16 -> 90 degree

int OUTPORTS[]={7,6,5,4};
//7 <-> in1(Motor Driver),6 <-> in2(Motor Driver),5 <-> in3(Motor Driver),4 <-> in4(Motor Driver), 

unsigned int ARR_DIST[MAX_POS+MIN_POS+1];
unsigned int ARR_DISTN[MAX_POS+MIN_POS+1];
int CUR;
int CURI;

//test function to rotate stepper motor to appropriate angle (6 steps clockwise, i.e.)
//to use this function: 1)rename setup0 -> setup, 2) rename setup (NEXT) -> setup0
void setup0() {
  for (int k=0;k<4;k++){
    pinMode(OUTPORTS[k],OUTPUT);
  }
  moveToPos(6,true);
}

void setup() {
  Serial.begin(9600);
  sensor.averaging=15;
  for (int k=0;k<4;k++){
    pinMode(OUTPORTS[k],OUTPUT);
  }

  CUR=MAX_POS;
  CURI=MAX_POS;
  scanI();
  moveToPos(MAX_POS+MIN_POS-CUR,false);
  delay(4000);
}

void loop() {
  toStart();
  scan();
  moveToPos(MAX_POS+MIN_POS-CUR,false);
  delay(5000);
}

void moveToPos(int pos, bool dir){
  for (int i=0;i<pos+0;i++){
    moveSteps(dir,64*32/64,2);
    delay(100);
  }
}

void toStart(){
  if(CUR>CURI)
  {
    moveToPos(CUR-CURI,false);
  }
  else
  {
    if(CUR<CURI)
    {
      moveToPos(CURI-CUR,true);
    }
  }
}


void scanI(){
  moveToPos(MIN_POS+6,false);
  unsigned int uS=sensor.distance();
  ARR_DIST[0]=uS;
  
  for(int i=0;i<MAX_POS+MIN_POS;i++){
    moveSteps(true,64*32/64,2);
    delay(500);
    uS=sensor.distance();
    ARR_DIST[i+1]=uS;
    delay(500);
  }
    for(int i=0;i<MAX_POS+MIN_POS+1;i++){
    Serial.println(ARR_DIST[i]);
  }
}

void scan(){
  int curMax;
  int maxN;
  moveToPos(MIN_POS,false);
  unsigned int uS=sensor.distance();
  ARR_DISTN[0]=uS;
  
  for(int i=0;i<MAX_POS+MIN_POS;i++){
    moveSteps(true,64*32/64,2);
    delay(500);
    uS=sensor.distance();
    delay(500);
    ARR_DISTN[i+1]=uS;
  }

  curMax=abs(ARR_DIST[0]-ARR_DISTN[0]);
  maxN=0;
  ARR_DIST[0]=ARR_DISTN[0];

  for(int i=1;i<=MAX_POS+MIN_POS;i++){
    if(abs(ARR_DIST[i]-ARR_DISTN[i])>curMax)
    {
      curMax=abs(ARR_DIST[i]-ARR_DISTN[i]);
      maxN=i;
    }
    ARR_DIST[i]=ARR_DISTN[i];
  }

  if(curMax>30)
  {
  CUR=maxN;
  }
}

void moveSteps(bool dir, int steps, byte ms) {
  for (int i = 0; i < steps; i++) {
    //Serial.println(i);
    moveOneStep(dir);
    delay(ms);
  }
}

void moveOneStep(bool dir) {
  static byte out = 0x01;
  if (dir) {
    out != 0x08 ? out = out << 1 : out = 0x01;
  }
  else {
    out != 0x01 ? out = out >> 1 : out = 0x08;
  }
  for (int i = 0; i < 4; i++) {
    digitalWrite(OUTPORTS[i], (out & (0x01 << i)) ? HIGH : LOW);
  }
}
